// Estimation of categorical model
//   f(y(t)|u(t),y(t-1))
// ------------------------------------------
clc, clear, close, mode(0)

u=[1 1 2 1 2 2 1 2 2 1 1 1 2 1 2];
y=[1 1 2 1 2 1 2 1 2 1 2 1 2 2 1];
nd=length(y)-1;
S=1e-8*ones(2,4);                       // initial statistics
// [u(t),y(t-1)] 11 12 21 22
//               ----------
//      y(t)=1 | x  x  x  x
//      y(t)=2 | x  x  x  x

// cumulation of statistics
for t=2:nd
  k=2*(u(t)-1)+y(t-1);                  // active column of the statistics
  S(y(t),k)=S(y(t),k)+1;                // increment of the statistics
end

// point estimates of parameters
for i=1:4
  th(:,i)=S(:,i)/sum(S(:,i));
end
disp('point estimates of parameters',th)
