// Estimation of regression model 
//   y(t)=a1*y(t-1)+b0*u(t)+e(t)
// -------------------------------------
clc, clear, close, mode(0)

nd=100;
a1=.6; b0=1;
y(1)=0;
u=rand(1,nd,'n')-1;
V=zeros(3,3); ka=0;

// time loop
for t=2:nd
  e(t)=rand(1,1,'n');
  y(t)=a1*y(t-1)+b0*u(t)+e(t);               //simulation
  
  Ps=[y(t) y(t-1) u(t)]';
  V=V+Ps*Ps';                                // statistics update
  ka=ka+1;
end

// results
Vy=V(1,1); Vyp=V(2:$,1); Vp=V(2:$,2:$);      // partitioning of V
th=inv(Vp)*Vyp                               // point estimates

set(scf(),'position',[800 100 600 400])
plot(1:nd,u,1:nd,y)
