// LS estimation of regression model 
// y(t)=a1*y(t-1)+b0*u(t)+e(t)
// -------------------------------------
clc, clear, close, mode(0)

nd=1000;
a1=.6; b0=1;
y(1)=0;
u=(rand(1,nd,'n')-1)+0*sin(2*%pi*(1:nd)/nd);
X=[]; Y=[];

// time loop
for t=2:nd
  e(t)=rand(1,1,'n');
  y(t)=a1*y(t-1)+b0*u(t)+e(t);          // simulation
  
  X=[X; [y(t-1) u(t)]];                 // construction of X
  Y=[Y; y(t)];                          // construction of Y
end

//results
th=inv(X'*X)*X'*Y                       // point estimate of reg. coef.

yp=X*th;
ep=y(2:$)-yp;
r=variance(ep)                          // point estimates of noise variance
