// Zero-step prediction with regression model
//   y(t)=bu(t)+a*y(t-1)+k+e(t)
// -------------------------------------
clc, clear, close, mode(0)

nd=120;
a=.7;
b=1;
k=-2;
sd=.1;
y(1)=1; u(2)=0;
aE=.5; bE=.1; kE=0;
V=1e-8*eye(4,4);
u=sin(6*%pi*(1:nd)/nd)+1;

for t=2:nd
  // prediction
  yp(t)=aE*y(t-1)+bE*u(t)+kE;

  // simulation
  y(t)=a*y(t-1)+b*u(t)+k+sd*rand(1,1,'n');

  // estimation
  Ps=[y(t) y(t-1) u(t) 1]';
  V=V+Ps*Ps';
  th=inv(V(2:$,2:$))*V(2:$,1);
  aE=th(1); bE=th(2); kE=th(3);
end

// results
set(scf(),'position',[800 100 600 400])
plot(1:nd,y,1:nd,yp)
title 'Continuous signal and its prediction'
legend('y','yp');

disp 'Simulated parameters'
a,b,k
disp 'Estimated parameters'
aE,bE,kE
