// State estimation
//   x(t)=Mx(t-1)+Nu(t)+w(t)
//   y(t)=Ax(t)+Bu(t)+v(t)
// -------------------------------------
clc, clear, close(winsid()), mode(0), getd()

nd=300;
M=[.9 .1 
   .2 .6];
N=[1
   -.5];
A=[.4 -.2];
B=.1;
x=[0
   0];
u=sin(6*%pi*(1:nd)/nd);

Rw=[.1 0;0 .2];
Rv=.1;
Rx=1000*eye(2,2);
xE=[0
    0];

for t=2:nd
  // simulation
  x=M*x+N*u(t)+[.1 0;0 .2]*rand(2,1,'n');
  y(t)=A*x+B*u(t)+.1*rand(1,1,'n');
  xt(:,t)=x;

  // estimation
  [xE,Rx,yp(t)]=Kalman(xE,y(t),u(t),M,N,A,B,Rw,Rv,Rx);
  xp(:,t)=xE;
end

set(scf(1),'position',[600 0 600 300])
plot([xt' xp'])
legend('xt1','xt2','xp1','xp2');
title 'State and its prediction'

set(scf(2),'position',[600 400 600 300])
plot([y yp])
legend('y','yp');
title 'Output and its prediction'
