// Classification using NB with known components
// -------------------------------------
clc, clear, close(winsid()), mode(0), 
function c=pmult(a,b)
  // polynomial multiplication
  // c(1,1)=a(1,1)*b(1,1); 
  // c(1,2)=a(1,1)*b(2,1);
  // c(1,3)=a(2,1)*b(1,1);
  // c(1,4)=a(2,1)*b(2,1);
  // c(2,1)=a(1,2)*b(1,2);
  // c(2,2)=a(1,2)*b(2,2);
  // c(2,3)=a(2,2)*b(1,2);
  // c(2,4)=a(2,2)*b(2,2);
  na=size(a,2);
  nb=size(b,2);
  n=size(a,1);
  k=0;
  for i=1:na
    for j=1:nb
      k=k+1;
      c(1:n,k)=a(:,i).*b(:,j);
    end
  end
endfunction

nd=100;
fx=[.3 .7;                              // [f(x1)
    .8 .2];                             //  f(x2)]
fx1Iy=[.3 .6                            // f(x1|y)
       .7 .4];
fx2Iy=[.99 .01                          // f(x2|y)
       .01 .99];      
fy=[.7 .3];                             // f(y)

fxx=pmult(fx1Iy,fx2Iy);                 // f(x1|y)*f(x2|y)
fyx=[fxx(1,:)*fy(1)                     // f(x1|y)*f(x2|y)*f(y)
     fxx(2,:)*fy(2)];
for i=1:4
  fyIx(:,i)=fyx(:,i)/sum(fyx(:,i));      // normalization -> f(y|x)
end

// time loop
for t=1:nd
  // simulation
  for i=1:2
    x(i,t)=sum(cumsum(fx(i,:))<rand(1,1,'u'))+1;
  end
  k=2*(x(1,t)-1)+x(2,t);
  y(t)=sum(cumsum(fyIx(:,k))<rand(1,1,'u'))+1;
  
  // classification: xt=[x1t,x2t] is the measured data record
  py=fx1Iy(x(1,t),:).*fx2Iy(x(2,t),:).*fy;  // f(x1t|y)*f(x2t|y)*f(y)
  [nill,yp(t)]=max(py);
end

// accuracy of classification
acc=sum(y==yp)/nd
