// Classification based on mixture estimation
// - on-line estimation
// - normal models  y(t)=k+e(t)
// -------------------------------------
clc, clear, close(winsid()), mode(0)                                  // 1
getd();                                                               // 2
                                                                      // 3
nd=100;                                                               // 4
// SIMULATION                                                         // 5
pS=[.4 .6];                                                           // 6
// c=1 =2                               components in columns         // 7
kS=[-1 1       // x1                    variables in rows             // 8
    -2 3];     // x2                                                  // 9
for t=1:nd                                                            // 10
  c(t)=sum(cumsum(pS)<rand(1,1,'u'))+1;                               // 11
  x(:,t)=kS(:,c(t))+.1*rand(1,1,'n');                                 // 12
end                                                                   // 13
                                                                      // 14
// ESTIMATION                                                         // 15
// c=1 =2                                                             // 16
m=[-2 5        // x1                                                  // 17
   -1 3];      // x2                    // prior parameters           // 18
ka=[1 1]';                              // prior counter              // 19
for j=1:2                                                             // 20
  S(:,j)=m(:,j)*ka(j);                  // prior statistics           // 21
end                                                                   // 22
                                                                      // 23
// time loop                                                          // 24
for t=1:nd                                                            // 25
  for j=1:2                                                           // 26
    q(j)=GaussN(x(:,t),m(:,j),.1*eye(2,2)); // proximity              // 27
  end                                       //  = fj(x=xt)            // 28
  w=q/sum(q);                           // weights                    // 29
  wt(:,t)=w;                                                          // 30
  for j=1:2                                                           // 31
    S(:,j)=S(:,j)+w(j)*x(:,t);          // statistics                 // 32
    ka(j)=ka(j)+w(j);                   //  update                    // 33
    m(:,j)=S(:,j)/ka(j);                // parameters                 // 34
  end                                                                 // 35
  [nill,cp(t)]=max(w);                  // CLASSIFICATION             // 36
end                                                                   // 37
                                                                      // 38
// ACCURACY of classification                                         // 39
acc=sum(c==cp)/nd                                                     // 40
