// Classification based on mixture estimation
// - on-line estimation
// - discrete models  f(x1,x2|c)
// -------------------------------------          
clc, clear, close(winsid()), mode(0)    
getd()
                                                                      // 3
nd=100;                                                               // 4
// SIMULATION                                                         // 5
pS=[.4 .6];                                                           // 6
//      c =1 =2                                                       // 7
thS(1).x=[.03 .98      // x1                                          // 8
          .97 .02];                                                   // 9
thS(2).x=[.99 .03      // x2                                          // 10
          .01 .97];                                                   // 11
for t=1:nd                                                            // 12
  c(t)=sum(cumsum(pS)<rand(1,1,'u'))+1;                               // 13
  for i=1:2                                                           // 14
    x(i,t)=sum(cumsum(thS(i).x(:,c(t)))<rand(1,1,'u'))+1;             // 15
  end                                                                 // 16
end                                                                   // 17
                                                                      // 18
// ESTIMATION                                                         // 19
thI=[pmult(thS(1).x(:,1)',thS(2).x(:,1)')'..                          // 20
     pmult(thS(1).x(:,2)',thS(2).x(:,2)')'];                          // 21
select 1  // 1=random, 2=with noise, 3=precise  init. parameters      // 22
case 1, th=rand(4,2,'u');                                             // 23
case 2, th=fnorm(thI+.1*(rand(4,2)-.5),1);                            // 24
case 3, th=thI;                                                       // 25
end                                                                   // 26
ka=[1 1];                              // prior counter               // 27
S=th.*(ones(4,1)*ka);                                                 // 28
                                                                      // 29
// time loop                                                          // 30
for t=1:nd                                                            // 31
  for j=1:2                                                           // 32
    k=2*(x(1,t)-1)+x(2,t);                                            // 33
    q(j)=th(k,j); // proximity = fj(x=xt)                             // 34
  end                                                                 // 35
  w=q/sum(q);                           // weights                    // 36
  wt(:,t)=w;                                                          // 37
  for j=1:2                                                           // 38
    k=2*(x(1,t)-1)+x(2,t);                                            // 39
    S(k,j)=S(k,j)+w(j);                 // statistics                 // 40
    th(:,j)=S(:,j)/sum(S(:,j));                                       // 42
  end                                                                 // 43
  th1(:,t)=th(:,1); th2(:,t)=th(:,2);                                 // 44
  [nill,cp(t)]=max(w);                  // CLASSIFICATION             // 45
end                                                                   // 46
                                                                      // 47
// ACCURACY of classification                                         // 48
disp 'Accuracy'                                                       // 49
acc=sum(c==cp)/nd                                                     // 50
disp 'Simulated parametrs'                                            // 51
thI                                                                   // 52
disp 'Parameter estimates'                                            // 53
thE=fix(th*10000)/10000                                               // 54
                                                                      // 55
set(scf(),'position',[800 20 600 600]);                               // 56
subplot(211), plot(th1')                                              // 57
title 'Evolution of the estimates - first component'                  // 58
subplot(212), plot(th2')                                              // 59
title 'Evolution of the estimates - second component'                 // 60
