function [p,Lp]=GaussN(x,m,R)
  // [p Lp]=GaussN(x,m,R)   value of multivariate Gaussian pdf          

  // p       probability
  // Lp      logarithm of prob.
  // x       realization
  // m       expectation
  // R       covariance matrix

  x=x(:);           // column vector
  m=m(:);           // column vector

  n=max(size(R));
  Lp=-.5*(n*log(2*%pi)+log(det(R)));  //pause
  ex=(x-m)'*inv(R+1e-8*eye(n,n))*(x-m);
  Lp=Lp-.5*ex;
  p=exp(Lp);
//  pause
endfunction
