function [q,T]=c2c(ct,Ect)
  // cc=c2c(ct,Ect)   permutation of pointer values for plot
  // ct      simulated pointer
  // Ect     estimated pointer
  // q       order vector for Ect
  // T       transf. matrix
  //
  // USSAGE:       ct=q(Ect)
  // set:  [q T]=c2c(ct,Ect);      simul and estim pointer
  // plot(1:nd,ct,1:nd,q(Ect))     plotting 
  //
  n=min([length(ct),length(Ect)]);
  if max(ct(1:n))~=max(Ect(1:n))
    disp 'WARNING from c2c.sci: Different numbers of components'
  end
  
  nc=max(ct);
  T=zeros(nc,nc);

  for t=1:n
    T(ct(t),Ect(t))=T(ct(t),Ect(t))+1;  // transformation matrix
  end

  for i=1:nc
    [xxx,q(i)]=max(T(:,i));             // order vector
  end
endfunction
