// Mixture estimation
// - 3 regression components, 2 variables
// - model: x=aj+e
// - sum statistics
// ------------------------------------------
clc, clear, close, mode(0)
getd c:\functions

nd=50;
a=list();
a(1)=[5 -1];
a(1)=[3 -1];
a(2)=[1  6];
a(3)=[2 -1];
al=[.3 .5 .2];
for t=1:nd
  c(t)=(sum(randu(1,1)>cumsum(al)))+1;
  x(t,:)=a(c(t))+.1*randn(1,2);
end
nc=length(a);

// Initialization
ni=1;                              // number of initial data
S=list(); th=list(); aI=list();
aI(1)=[4 0];                       // initial parameters
aI(2)=[0 5];
aI(3)=[1 0];
ka=ni*ones(1,nc);                  // counter
for j=1:nc                         // initialstatistics
  S(j)=aI(j)*ka(j);
  th(j)=S(j)/ka(j);
end

//  Estimation
t1=[]; t2=[]; t3=[];
for t=1:nd
  for j=1:nc
    [nill,qL(j)]=GaussN(x(t,:),th(j),.1);
  end
  qp=qL-max(qL); q=exp(qp);  //pause
  w=fnorm(q);
  wt(:,t)=w;
  for j=1:nc
    S(j)=S(j)+w(j)*x(t,:);
    ka(j)=ka(j)+w(j);
    th(j)=S(j)/ka(j);
  end
  t1=[t1; th(1)]; t2=[t2; th(2)]; t3=[t3; th(3)];
end

[nill,cp]=max(wt,'r');
scf(); 
plot(t1(:,1),t1(:,2),'.:')
plot(t2(:,1),t2(:,2),'g.:')
plot(t3(:,1),t3(:,2),'r.:')
plot(aI(1)(1),aI(1)(2),'ko','markersize',8)
plot(a(1)(1),a(1)(2),'kx','markersize',14)
plot(a(1)(1),a(1)(2),'ko','markersize',14)
plot(aI(2)(1),aI(2)(2),'ko','markersize',8)
plot(a(2)(1),a(2)(2),'kx','markersize',14)
plot(a(2)(1),a(2)(2),'ko','markersize',14)
plot(aI(3)(1),aI(3)(2),'ko','markersize',8)
plot(a(3)(1),a(3)(2),'kx','markersize',14)
plot(a(3)(1),a(3)(2),'ko','markersize',14)
title 'Evolution of parameter estimates (o-start, ox-end)'

