// Dynamic components
// ------------------------------------------
clc, clear, close, mode(0)
getd c:\functions

nd=500;
// Simulation
a=list();
a(1)=[.5 -1 0 5];
a(2)=[-.8 6 -1 -3];
a(3)=[.1 -1 8 0];
al=[.3 .5 .2];
u=rand(1,nd,'n');
y=0;
for t=2:nd
  c(t)=(sum(randu(1,1)>cumsum(al)))+1;
  ac=a(c(t));
  y(t)=ac(1)*y(t-1)+ac(2)*u(t)+ac(3)*u(t-1)+ac(4)+.1*randn(1,1);
end
nc=length(a);

// Initiation
V=list(); th=list(); aI=list();
select 1
case 1, aI(1)=[1 0 0 4]; aI(2)=[-1 5 0 -2]; aI(3)=[1 0 7 0];
case 2, aI=a; for i=1:3, aI(i)=aI(i)+.5*rand(1,4,'n'); end
end  
ka=ones(1,nc);
for j=1:nc
  V(j)=eye(5,5); V(j)(2:$,1)=aI(j)'; V(j)(1,2:$)=aI(j); 
  th(j)=v2thN(V(j)/ka(j),1);
end
t1=th(1); t2=th(2); t3=th(3);

// Estimation
for t=2:nd
  for j=1:nc
    // proximities
    [nill,qL(j)]=GaussN(y(t),[y(t-1) u(t) u(t-1) 1]*th(j),.1);
  end
  qp=qL-max(qL); q=exp(qp);
  w=fnorm(q);                           // weights
  wt(:,t)=w;
  for j=1:nc                            // update of statistics
    Ps=[y(t) y(t-1) u(t) u(t-1) 1];
    V(j)=V(j)+w(j)*Ps'*Ps;
    ka(j)=ka(j)+w(j);
    th(j)=v2thN(V(j)/ka(j),1); 
    t1=[t1 th(1)]; t2=[t2 th(2)]; t3=[t3 th(3)];  // remember
  end
end
[nill,cp]=max(wt,'r');

// Results
set(scf(),'position',[50 100 500 600]);
subplot(211)
plot(t1(1,:),t1(2,:),'.:')
plot(t2(1,:),t2(2,:),'.:')
plot(t3(1,:),t3(2,:),'.:')
for i=1:3
plot(aI(i)(1),aI(i)(2),'ko','markersize',8)
plot(th(i)(1),th(i)(2),'kx','markersize',14)
plot(th(i)(1),th(i)(2),'ko','markersize',14)
plot(a(i)(1),a(i)(2),'rp','markersize',8)
end
title 'Space evolution of the first two parameters'
subplot(212)
plot(t1(3,:),t1(4,:),'.:')
plot(t2(3,:),t2(4,:),'.:')
plot(t3(3,:),t3(4,:),'.:')
for i=1:3
plot(aI(i)(3),aI(i)(4),'ko','markersize',8)
plot(th(i)(3),th(i)(4),'kx','markersize',14)
plot(th(i)(3),th(i)(4),'ko','markersize',14)
plot(a(i)(3),a(i)(4),'rp','markersize',8)
end
title 'Space evolution of the last two parameters'

set(scf(),'position',[600 100 600 600]);
title 'Time evolution of parameters'
subplot(311),plot(t1')
subplot(312),plot(t2')
subplot(313),plot(t3')
