// Mixture estimation
// - 3 categorical components, 1 variable 
//   (for more variables x use coding)
// - x=1,2,3,4
// - model: f(x|c=j), j=1,2,3
// - attempt to improve the estimates (repetitive run)
// ------------------------------------------
clc, clear, close, mode(0)
getd c:\functions

nd=100;
a=list();
a(1)=[.2 .02 .03 .75];
a(2)=[.03 .95 .01 .01];
a(3)=[.05 .03 .9 .02];
al=[.3 .5 .2];
for t=1:nd
  c(t)=(sum(cumsum(al)<randu(1,1)))+1;
  x(t,:)=(sum(cumsum(a(c(t)))<randu(1,1)))+1;
end
nc=length(a);

// Initialization
ni=10;                              // number of initial data
S=list(); th=list(); aI=list();
aI(1)=[.1 .05 .1 .75];             // initial parameters
aI(2)=[.1 .7 .1 .1];
aI(3)=[.01 .05 .9 .04];
if 1                     // CONTINUE ESTIMATION ? 1-yes, 0-no
  load S.dat S;                    // stat. from previous run
  for j=1:nc
    S(j)=S(j)/sum(S(j))*ni;
  end
else
  for j=1:nc                         // initial statistics
    S(j)=aI(j)*ni;
  end
end
for j=1:nc
  th(j)=S(j)/sum(S(j));
end

//  Estimation
t1=[]; t2=[]; t3=[];
for t=1:nd
  for j=1:nc
    q(j)=th(j)(x(t));
  end
  w=fnorm(q); w=dDel(w);
  wt(:,t)=w;
  for j=1:nc
    S(j)(x(t))=S(j)(x(t))+w(j);
    th(j)=S(j)/sum(S(j));
  end
  t1=[t1; th(1)]; t2=[t2; th(2)]; t3=[t3; th(3)]; //pause
end
save S.dat S

[nill,cp]=max(wt,'r');
scf(); 
plot(t1(:,1),t1(:,2),'.:')
plot(t2(:,1),t2(:,2),'g.:')
plot(t3(:,1),t3(:,2),'r.:')
plot(aI(1)(1),aI(1)(2),'ko','markersize',8)
plot(a(1)(1),a(1)(2),'kx','markersize',14)
plot(a(1)(1),a(1)(2),'ko','markersize',14)
plot(aI(2)(1),aI(2)(2),'ko','markersize',8)
plot(a(2)(1),a(2)(2),'kx','markersize',14)
plot(a(2)(1),a(2)(2),'ko','markersize',14)
plot(aI(3)(1),aI(3)(2),'ko','markersize',8)
plot(a(3)(1),a(3)(2),'kx','markersize',14)
plot(a(3)(1),a(3)(2),'ko','markersize',14)
title 'Evolution of parameter estimates (o-start, ox-end)'

ACC=acc(c,cp)
